Panda3D

Public Member Functions | List of all members
CharacterMaker Class Reference

Converts an EggGroup hierarchy, beginning with a group with <Dart> set, to a character node with joints. More...

`#include "characterMaker.h"`

## Public Member Functions
| CharacterMaker (EggGroup *root, EggLoader &loader, bool structured=false)
int | create_slider (const std::string &name)
| Creates a new morph slider of the given name, and returns its index. More...
int | egg_to_index (EggNode *egg_node) const
| Returns the index number associated with the PartGroup node for the given egg node, or -1. More...
PartGroup * | egg_to_part (EggNode *egg_node) const
| Returns the PartGroup node associated with the given egg node. More...
VertexSlider * | egg_to_slider (const std::string &name)
| Returns the VertexSlider corresponding to the indicated egg slider name. More...
VertexTransform * | egg_to_transform (EggNode *egg_node)
| Returns a JointVertexTransform suitable for applying the animation associated with the given egg node (which should be a joint). More...
std::string | get_name () const
| Returns the name of the character. More...
Character * | make_node ()
PandaNode * | part_to_node (PartGroup *part, const std::string &name) const
| Returns the scene graph node associated with the given PartGroup node, if there is one. More...

## Detailed Description

Converts an EggGroup hierarchy, beginning with a group with <Dart> set, to a character node with joints.

Definition at line 45 of file characterMaker.h.

## Member Function Documentation

## ◆ create_slider()

int CharacterMaker::create_slider | ( | const std::string & | name | ) |

Creates a new morph slider of the given name, and returns its index.

Definition at line 172 of file characterMaker.cxx.

## ◆ egg_to_index()

int CharacterMaker::egg_to_index | ( | EggNode * | egg_node | ) | const

Returns the index number associated with the PartGroup node for the given egg node, or -1.

Definition at line 125 of file characterMaker.cxx.

Referenced by egg_to_part(), and egg_to_transform().

## ◆ egg_to_part()

PartGroup * CharacterMaker::egg_to_part | ( | EggNode * | egg_node | ) | const

Returns the PartGroup node associated with the given egg node.

If the egg node is not a node in the character's hierarchy, returns the top of the character's hierarchy.

Definition at line 80 of file characterMaker.cxx.

References egg_to_index().

## ◆ egg_to_slider()

VertexSlider * CharacterMaker::egg_to_slider | ( | const std::string & | name | ) |

Returns the VertexSlider corresponding to the indicated egg slider name.

Definition at line 186 of file characterMaker.cxx.

## ◆ egg_to_transform()

VertexTransform * CharacterMaker::egg_to_transform | ( | EggNode * | egg_node | ) |

Returns a JointVertexTransform suitable for applying the animation associated with the given egg node (which should be a joint).

Returns an identity transform if the egg node is not a joint in the character's hierarchy.

Definition at line 98 of file characterMaker.cxx.

References egg_to_index().

## ◆ get_name()

string CharacterMaker::get_name | ( |  | ) | const

Returns the name of the character.

Definition at line 70 of file characterMaker.cxx.

## ◆ part_to_node()

PandaNode * CharacterMaker::part_to_node | ( | PartGroup * | part,
|  | const std::string & | name
| ) |  | const

Returns the scene graph node associated with the given PartGroup node, if there is one.

If the PartGroup does not have an associated node, returns the character's top node.

Definition at line 139 of file characterMaker.cxx.

References PartGroup::is_character_joint().

The documentation for this class was generated from the following files:

- panda/src/egg2pg/characterMaker.h
- panda/src/egg2pg/characterMaker.cxx